; QDesign_config Basic extension, reverse engineered by Marcel Kilgus

	section config

	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_mac_proc'

config_init
	lea	config_procs,a1
	move.w	sb.inipr,a2
	jmp	(a2)

config_procs
	proc_stt
	proc_end
	proc_stt
	proc_ref CHECK%,check_int
	proc_ref CHECKF,check_float
	proc_end

check_ipar
	moveq	#err.ipar,d0
check_ret
	rts

; val = CHECK%(string). -32768 on error

check_int:
	moveq	#1,d5
check_all:
	movea.l sb_arthp(a6),a4 ; arithmetic stack pointer
	movea.w sb.gtstr,a0
	jsr	(a0)
	bne.s	check_ret
	subq.w	#1,d3		; Only one string please
	bne.s	check_ipar
	movea.l a1,a0
	adda.w	(a1,a6.l),a0
	addq.l	#2,a0		; End of string
	move.l	a0,d7
	lea	2(a1),a0	; Start of string
	tst.w	d5
	beq.s	check_float	; val = CHECK_FLOAT(string). -1E600 on error
	moveq	#2,d1
	suba.l	d1,a4
	movea.w qa.resri,a2
	jsr	(a2)
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	movea.w cv.deciw,a2
	jsr	(a2)
	beq.s	check_int_ok
	move.w	#$8000,(a4,a6.l)
	bra.s	check_int_ret
check_int_ok
	move.w	(a1,a6.l),(a4,a6.l)
check_int_ret
	move.l	a4,sb_arthp(a6) ; arithmetic stack pointer
	moveq	#nt.in,d4
	moveq	#0,d0
	rts


; val = CHECK_FLOAT(string). -1E600 on error

check_float
	moveq	#6,d1
	suba.l	d1,a4
	movea.w qa.resri,a3
	jsr	(a3)
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	movea.w cv.decfp,a2
	jsr	(a2)
	beq.s	check_float_ok
	move.w	#$FCA,(a4,a6.l) ; -1E600
	move.w	#$B8A6,2(a4,a6.l)
	move.w	#$3468,4(a4,a6.l)
	bra.s	check_float_ret

check_float_ok
	move.l	2(a1,a6.l),2(a4,a6.l)
	move.l	(a1,a6.l),(a4,a6.l)

check_float_ret
	move.l	a4,sb_arthp(a6) ; arithmetic stack pointer
	moveq	#nt.fp,d4
	moveq	#0,d0
	rts

	end
